<!DOCTYPE html>
<html>
  <head>
    <title>JSON Data to HTML Table</title>
    <style>
      table,
      th,
      td {
        border: 1px solid black;
      }
      th {
        cursor: pointer;
      }
    </style>
  </head>
  <body>
    <input type="button" onclick="tableFromJson()" value="JSON data" />
    <input
      type="text"
      id="myInput"
      onkeyup="myFunction()"
      placeholder="Search for names.."
      title="Type in a name"
    />
    <p><button onclick="sortTable()">Sort</button></p>

    <p id="showData"></p>
  </body>
  <script>
    let tableFromJson = () => {
      // the json data.
      const myFriends = [
        {
          name: "Beka",
          id: 5,
        },
        {
          name: "Janbik",
          id: 4,
        },
        {
          name: "Zhan",
          id: 6,
        },
        {
          name: "Aray",
          id: 3,
        },
        {
          name: "Asel",
          id: 2,
        },
        {
          name: "Jandos",
          id: 1,
        },
      ];
      let col = [];
      for (let i = 0; i < myFriends.length; i++) {
        for (let key in myFriends[i]) {
          if (col.indexOf(key) === -1) {
            col.push(key);
          }
        }
      }

      const table = document.createElement("table");

      let tr = table.insertRow(-1);

      for (let i = 0; i < col.length; i++) {
        let th = document.createElement("th");
        th.innerHTML = col[i];
        tr.appendChild(th);
      }

      for (let i = 0; i < myFriends.length; i++) {
        tr = table.insertRow(-1);

        for (let j = 0; j < col.length; j++) {
          let tabCell = tr.insertCell(-1);
          tabCell.innerHTML = myFriends[i][col[j]];
        }
      }

      const divShowData = document.getElementById("showData");
      divShowData.innerHTML = "";
      divShowData.appendChild(table);
    };
    const getCellValue = (tr, idx) =>
      tr.children[idx].innerText || tr.children[idx].textContent;

    const comparer = (idx, asc) => (a, b) =>
      ((v1, v2) =>
        v1 !== "" && v2 !== "" && !isNaN(v1) && !isNaN(v2)
          ? v1 - v2
          : v1.toString().localeCompare(v2))(
        getCellValue(asc ? a : b, idx),
        getCellValue(asc ? b : a, idx)
      );

    document.querySelectorAll("th").forEach((th) =>
      th.addEventListener("click", () => {
        const table = th.closest("table");
        Array.from(table.querySelectorAll("tr:nth-child(n+2)"))
          .sort(
            comparer(
              Array.from(th.parentNode.children).indexOf(th),
              (this.asc = !this.asc)
            )
          )
          .forEach((tr) => table.appendChild(tr));
      })
    );
    function myFunction() {
      let input, filter, table, tr, td, i, txtValue;
      input = document.getElementById("myInput");
      filter = input.value.toUpperCase();
      table = document.getElementById("showData");
      tr = table.getElementsByTagName("tr");
      for (i = 0; i < tr.length; i++) {
        td = tr[i].getElementsByTagName("td")[0];
        if (td) {
          txtValue = td.textContent || td.innerText;
          if (txtValue.toUpperCase().indexOf(filter) > -1) {
            tr[i].style.display = "";
          } else {
            tr[i].style.display = "none";
          }
        }
      }
    }
    function sortTable() {
      let data, table, tbody, rows, switching, i, x, y, shouldSwitch;
      tbody = document.querySelector("tbody");
      switching = true;

      while (switching) {
        switching = false;
        rows = tbody.rows;

        for (i = 1; i < rows.length - 1; i++) {
          shouldSwitch = false;

          x = rows[i].getElementsByTagName("td")[1];
          y = rows[i + 1].getElementsByTagName("td")[1];

          if (Number(x.innerHTML) > Number(y.innerHTML)) {
            shouldSwitch = true;
            break;
          }
        }
        if (shouldSwitch) {
          rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
          switching = true;
        }
      }
    }
  </script>
</html>
